/*
 * 商品运费模板
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class ProductFareTempController : BaseController
    {
        public ProductFareTempController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 商品运费模板列表

        /// <summary>
        /// 根据条件查询商品运费模板列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(ProductFareTemp data, string right, string MerchantId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.MerchantId = MerchantId;

            string Condition = "";
            Condition += "Name:\"" + data.Name + "\",";
            Condition += "MeterMode:\"" + data.MeterMode + "\",";
            Condition += "TransportMode:\"" + data.TransportMode + "\",";

            if (!string.IsNullOrEmpty(Condition))
            {
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询商品运费模板列表

        /// <summary>
        /// 商品运费模板列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(ProductFareTemp data, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("MerchantId", "1");
            Fields.Add("Name", "2"); //名称
            Fields.Add("MeterMode", "1"); //计价方式
            Fields.Add("TransportMode", "1"); //运送方式

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ProductFareTemp", Fields, "Id desc", "False", page, limit);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["IsFree"] = dic["IsFree"].ToString() == "1" ? "是" : "否";
            }
            return Json(obj);
        }

        #endregion

        #region 增加商品运费模板

        /// <summary>
        /// 增加或修改商品运费模板信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string MerchantId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.MerchantId = MerchantId;

            return View();
        }

        #endregion

        #region 增加商品运费模板

        /// <summary>
        /// 增加或修改商品运费模板信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(ProductFareTemp data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("MerchantId", data.MerchantId);
            Fields.Add("Name", data.Name); //名称
            Fields.Add("SendAreas", data.SendAreas); //发货地区
            Fields.Add("SendAddress", data.SendAddress); //发货地址
            Fields.Add("SendDate", data.SendDate); //发货时间
            Fields.Add("IsFree", data.IsFree); //是否包邮
            Fields.Add("MeterMode", data.MeterMode); //计价方式
            Fields.Add("TransportMode", data.TransportMode); //运送方式
            Fields.Add("FirstAmount", data.FirstAmount); //首件数量
            Fields.Add("FirstFee", data.FirstFee); //首件费用
            Fields.Add("MoreAmount", data.MoreAmount); //续件数量
            Fields.Add("MoreFee", data.MoreFee); //续件费用
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("ProductFareTemp", Fields, 0);
            JsonData jsonObj = JsonMapper.ToObject(data.SeoDescription);
            for (int i = 0; i < jsonObj.Count; i++)
            {
                string area = jsonObj[i]["area"].ToString();
                decimal firstAmount = decimal.Parse(function.CheckNum(jsonObj[i]["firstAmount"].ToString()));
                decimal firstFee = decimal.Parse(function.CheckNum(jsonObj[i]["firstFee"].ToString()));
                decimal moreAmount = decimal.Parse(function.CheckNum(jsonObj[i]["moreAmount"].ToString()));
                decimal moreFee = decimal.Parse(function.CheckNum(jsonObj[i]["moreFee"].ToString()));
                db.ProductFareAreas.Add(new ProductFareAreas() {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    MerchantId = data.MerchantId,
                    TemplateId = Id,
                    Areas = area,
                    FirstAmount = firstAmount,
                    FirstFee = firstFee,
                    MoreAmount = moreAmount,
                    MoreFee = moreFee,
                });
            }
            AddSysLog(data.Id.ToString(), "ProductFareTemp", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改商品运费模板

        /// <summary>
        /// 增加或修改商品运费模板信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string MerchantId, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.MerchantId = MerchantId;

            ProductFareTemp editData = db.ProductFareTemp.FirstOrDefault(m => m.Id == Id) ?? new ProductFareTemp();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改商品运费模板

        /// <summary>
        /// 增加或修改商品运费模板信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(ProductFareTemp data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("Name", data.Name); //名称
            Fields.Add("SendAreas", data.SendAreas); //发货地区
            Fields.Add("SendAddress", data.SendAddress); //发货地址
            Fields.Add("SendDate", data.SendDate); //发货时间
            Fields.Add("IsFree", data.IsFree); //是否包邮
            Fields.Add("MeterMode", data.MeterMode); //计价方式
            Fields.Add("TransportMode", data.TransportMode); //运送方式
            Fields.Add("FirstAmount", data.FirstAmount); //首件数量
            Fields.Add("FirstFee", data.FirstFee); //首件费用
            Fields.Add("MoreAmount", data.MoreAmount); //续件数量
            Fields.Add("MoreFee", data.MoreFee); //续件费用
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProductFareTemp", Fields, data.Id);
            JsonData jsonObj = JsonMapper.ToObject(data.SeoDescription);
            for (int i = 0; i < jsonObj.Count; i++)
            {
                string area = jsonObj[i]["area"].ToString();
                decimal firstAmount = decimal.Parse(function.CheckNum(jsonObj[i]["firstAmount"].ToString()));
                decimal firstFee = decimal.Parse(function.CheckNum(jsonObj[i]["firstFee"].ToString()));
                decimal moreAmount = decimal.Parse(function.CheckNum(jsonObj[i]["moreAmount"].ToString()));
                decimal moreFee = decimal.Parse(function.CheckNum(jsonObj[i]["moreFee"].ToString()));

                ProductFareAreas check = db.ProductFareAreas.FirstOrDefault(m => m.MerchantId == data.MerchantId && m.TemplateId == data.Id && m.Areas == area);
                if (check == null)
                {
                    db.ProductFareAreas.Add(new ProductFareAreas()
                    {
                        CreateDate = DateTime.Now,
                        UpdateDate = DateTime.Now,
                        MerchantId = data.MerchantId,
                        TemplateId = data.Id,
                        Areas = area,
                        FirstAmount = firstAmount,
                        FirstFee = firstFee,
                        MoreAmount = moreAmount,
                        MoreFee = moreFee,
                    });
                }
                else
                {
                    check.UpdateDate = DateTime.Now;
                    check.Areas = area;
                    check.FirstAmount = firstAmount;
                    check.FirstFee = firstFee;
                    check.MoreAmount = moreAmount;
                    check.MoreFee = moreFee;
                }
            }
            AddSysLog(data.Id.ToString(), "ProductFareTemp", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除商品运费模板信息

        /// <summary>
        /// 删除商品运费模板信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ProductFareTemp", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Delete("ProductFareTemp", id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ProductFareTemp", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProductFareTemp", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "ProductFareTemp", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("ProductFareTemp", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("ProductFareTemp", Sort, Id);

            AddSysLog(Id.ToString(), "ProductFareTemp", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.ProductFareTemp.Add(new ProductFareTemp()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "ProductFareTemp", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(ProductFareTemp data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("Name", "2"); //名称
            Fields.Add("MeterMode", "1"); //计价方式
            Fields.Add("TransportMode", "1"); //运送方式

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("ProductFareTemp", Fields, "Id desc", "False", 1, 20000, "", "", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "ProductFareTemp", "ExportExcel");
            return Json(result);
        }

        #endregion



        public JsonResult GetTemplate(int MerchantId)
        {
            List<ProductFareTemp> list = db.ProductFareTemp.Where(m => m.MerchantId == MerchantId).OrderByDescending(m => m.Sort).ThenByDescending(m => m.Id).ToList();
            return Json(list);
        }
    }
}
